import chess.pgn
import chess
import sys
from collections import defaultdict

checking = sys.argv[1]
assert(checking == 'easy' or checking == 'hard')
f = open(sys.argv[2])

try:
    game = chess.pgn.read_game(f)
except Exception as msg:
    print 'Wrong answer: Failed to parse the game ({}).'.format(msg)
    sys.exit(1)

node = game

if not node:
  print 'Wrong answer: Failed to parse the game (empty game).'
  sys.exit(1)

while node.variations:
    next_node = node.variation(0)
    node = next_node

counter = defaultdict(int)

for i in range(64):
  piece = node.board().piece_at(i)
  if piece:
    counter[str(piece)] += 1

if checking == 'easy':
  for x in counter:
    if counter[x] > 8:
      print "OK"
      sys.exit(0)
  print "Wrong answer: Too few pieces of each type."
  sys.exit(1)

if checking == 'hard':
  if counter['R'] + counter['r'] < 20:
    print "Wrong answer: Too few rooks."
    sys.exit(1)
  print "OK"
  sys.exit(0)
